<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/29/2003 *
 * ===============                              Last change: 12/03/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : stylesheet.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Stylesheets are stored here                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Style-Sheets werden hier abgelegt                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Default styles
$STYLES = array(
		"general.css",
);

// Add stylesheet for installation
if ((basename($_SERVER['PHP_SELF']) == "install.php") || (!isBooleanConstantAndTrue('mxchange_installed')) || (isset($_GET['installing']))) $STYLES[] = "install.css";

// When no CSS output-mode is set, set it to file-output
if (!isConfigEntrySet('css_php')) setConfigEntry('css_php', "FILE");

// Output CSS files or content or link to css.php ?
if (($GLOBALS['output_mode'] == "1") || (getConfig('css_php') == "DIRECT")) {
	// Load CSS files
	if (is_array($EXT_CSS_FILES)) {
		// Load extension's CSS files
		foreach ($EXT_CSS_FILES as $value) $STYLES[] = $value;
	} // END - if

	// Output inclusion lines
	foreach ($STYLES as $value) {
		// Only include found CSS files (to reduce 404 requests)
		$BASE = sprintf("%stheme/%s/css/", constant('PATH'), GET_CURR_THEME());
		$FQFN = $BASE.$value;

		// Do include only existing files and whose are not empty
		if ((FILE_READABLE($FQFN)) && (filesize($FQFN) > 0)) {
			switch (getConfig('css_php')) {
				case "DIRECT":
					OUTPUT_HTML("<link rel=\"stylesheet\" type=\"text/css\" href=\"{!URL!}/theme/".GET_CURR_THEME()."/".$value."\" />");
					break;

				case "FILE":
					OUTPUT_HTML(READ_FILE($FQFN));
					break;
			} // END - switch
		} // END - if
	} // END - foreach
} else {
	// Now we load all CSS files from css.php!
	OUTPUT_HTML("<link rel=\"stylesheet\" type=\"text/css\" href=\"{!URL!}/css.php", false);
	if (isBooleanConstantAndTrue('mxchange_installing')) {
		// Default theme first
		$NEW_THEME = "default";
		if (!empty($_GET['theme']))  $NEW_THEME = SQL_ESCAPE($_GET['theme']);
		if (!empty($_POST['theme'])) $NEW_THEME = SQL_ESCAPE($_POST['theme']);
		OUTPUT_HTML("?theme=".$NEW_THEME."&amp;installing=1", false);
	} // END - if
	OUTPUT_HTML("\" />");
}

//
?>
